package de.ozgcloud.nachrichten.postfach.bayernid;

import de.ozgcloud.nachrichten.postfach.PostfachException;
import de.ozgcloud.nachrichten.postfach.PostfachMessageCode;

class BayernIdServerException extends PostfachException {

	static final String TABELLE_NUMMER_EMPFANG_ERGEBNISSTATUS = "9006";
	private static final String ERROR_MESSAGE_TEMPLATE = TABELLE_NUMMER_EMPFANG_ERGEBNISSTATUS + " / %s / %s / %s";

	private final MailSendingResponseStatus mailSendingResponseStatus;

	public BayernIdServerException(String message) {
		super(message, PostfachMessageCode.PROCESS_FAILED_MESSAGE_CODE);
		this.mailSendingResponseStatus = null;
	}

	public BayernIdServerException(String message, MailSendingResponseStatus mailSendingResponseStatus) {
		super(message, PostfachMessageCode.PROCESS_FAILED_MESSAGE_CODE);
		this.mailSendingResponseStatus = mailSendingResponseStatus;
	}

	@Override
	public String getMessage() {
		if (mailSendingResponseStatus == null) {
			return super.getMessage();
		}
		return ERROR_MESSAGE_TEMPLATE.formatted(mailSendingResponseStatus.getSchluessel(), mailSendingResponseStatus.getMessage(), super.getMessage());
	}
}
